



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>MySQL优化特定类型的查询</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">MySQL优化特定类型的查询</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 01:33:09 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>优化关联查询</h2>
<p>如果想要优化使用关联的查询，我们需要特别留意以下几点：</p>
<ol><li>确保ON或者USING子句中的列上有索引。在创建索引的时候需要考虑到关联的顺序。当表A和表B用列c关联的时候，如果优化器的关联顺序是B、A，那么就不需要在B表的对应列上建索引。除非有其他理由，否则只需要在关联顺序的第二个表的对应列上创建索引，没有用的索引只会带来额外的负担。</li>
<li>确保任何的GROUP BY 和 ORDER BY 中的表达式只涉及一个表中的列，这样MySQL才有可能使用索引来优化这个过程。</li>
<li>当升级MySQL的时候需要注意：关联语法、运算符优先级等其他可能会发生变化的地方。</li></ol>
<h2>优化GROUP BY 和 DISTINCT</h2>
<p>在很多场景下，MySQL都使用同样的办法优化这两种查询，事实上MySQL优化器会在内部处理的时候相互转换这两类查询。它们都可以使用索引来优化，这也是最有效的优化办法。</p>
<p>当无法使用索引的时候，GROUP BY使用两种策略来完成：使用临时表或者文件排序来做分组。对于任何查询语句，这两种策略的性能都可有可以提升的地方。我们可以通过提示 SQL_BIG_RESULT 和 SQL_SMALL_RESULT 来让优化器按照你希望的方式运行。</p>
<h2>优化LIMIT 分页</h2>
<p>在系统中需要进行分页操作的时候，我们通常会使用LIMIT 加上偏移量的方法实现，同时加上合适的ORDER BY 子句。如果有对应的索引，通常效率会不错，否则，MySQL需要做大量的文件排序操作。</p>
<p>但是有一个非常常见又头疼的问题就是，在偏移量非常大的时候，例如可能是 LIMIT 10000,20这样的查询，此时MySQL需要查询10020 条记录并只返回最后的20条，这样的代价非常高。</p>
<p>如果所有的页面被访问的频率都相同，那么这样的查询平均需要访问半个表的数据。要优化这种查询，要么是在页面中限制分页的数量，要么是优化大偏移量的性能。</p>
<p>优化此类分页查询的一个最简单的办法就是尽可能地使用索引覆盖扫描，而不是查询所有的列。然后根据需要做一次关联操作最后返回所需要的列。对于偏移量很大的时候，这样做的效率会提高很多。考虑下面这个查询：</p>
<pre class="prettyprint linenums"><code>SELECT file_id, description FROM sakila.film<br />
ORDER BY title LIMTI 50, 5;<br />
</code></pre>
<p>如果这个表很大，最好可以将这个查询修改成下面这个样子：</p>
<pre class="prettyprint linenums"><code>SELECT file.file_id, file.description<br />
FROM sakila.film<br />
    INNER JOIN(<br />
        SELECT film_id FROM sakila.film<br />
        ORDER BY title LIMIT 50, 5<br />
    )<br />
</code></pre>
<p>这里的“延迟关联”将大大提高查询效率，它让MySQL扫描尽可能少的页面，获取需要访问的记录后再根据关联列回原表查询所需要的所有列。</p>
<p>还有另外一种优化的方法，就是使用应用程序记录上次数据的位置，在下次查询时就可以直接从该记录的位置开始扫描，这样就避免了使用OFFSET。</p>
<p>使用这样的方法可以将其变成一个范围查询，无论翻页到多后面，其性能都会很好。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqln20k8.html">C语言回顾-结构体、枚举和文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kk6o38.html">Magicodes&period;Shop&mdash;&mdash;版本历史</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjmdj49.html">Matlab设置网格线密度（坐标精度）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde71lx9.html">HDU 4611Balls Rearrangement&lpar;思维&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yxrv08.html">OpenRisc-32-ORPSoC烧写外部spi flash</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kzoo29.html">JAVA进阶----主线程等待子线程各种方案比较（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yjl3w8.html">UITableView的子控件高度不确定处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpkvl69.html">NHibernate教程&lpar;19&rpar; &mdash;&mdash; 一级缓存</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zxzwj9.html">BS架构和CS架构的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1edggq.html">【Spring Boot】关于上传文件例子的剖析</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd12o49.html">win10下配置默认软件（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwejjv9.html">C&plus;&plus;中cin&period;getline与cin&period;get要注意的地方</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvw3r38.html">尚硅谷面试第一季-17Redis 在项目中的使用场景</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o13v4pq.html">Unity中UGUI鼠标穿透UI问题的解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj634j9.html">Cocos2dx网络读取图片</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjyxle9.html">iOS-Core-Animation-Advanced-Techniques&sol;13-高效绘图 【没理解】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdvk2e9.html">mysql存储过程中使用游标</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jm0y0w9.html">POJ1274 The Perfect Stall&lbrack;二分图最大匹配 Hungary&rsqb;【学习笔记】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjj7gzq.html">C&plus;&plus; 著名程序库 概览</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em5zlj9.html">Java 8 Lambda实现原理分析</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9jz535g8.html">关于js的页面高度和滚动条高度还有元素高度</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp774zq.html">DOS命令（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv146njq.html">Linux下CenOS系统 安装Redis</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpxy779.html">CASE WHEN 高阶用法&quest;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv14xrzq.html">Druid的简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyzdwk9.html">sha256 js 前端加密</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojmx45q.html">Python 远程开机</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj6zz09.html">&lbrack;Swift&rsqb;LeetCode147&period; 对链表进行插入排序 &vert; Insertion Sort List</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv16vk1q.html">Kubernetes---Pod控制器</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyn13x9.html">PowerShell 中 RunspacePool 执行异步多线程任务</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
